using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;

namespace PaintDotNet
{
    /// <summary>
    /// Summary description for MainToolBarForm.
    /// </summary>
    public class MainToolBarForm 
        : FloatingToolForm
    {
        public MainToolBar MainToolBar
        {
            get
            {
                return mainToolBar;
            }
        }

        private PaintDotNet.MainToolBar mainToolBar = null;

        /// <summary>
        /// Required designer variable.
        /// </summary>
        private System.ComponentModel.Container components = null;

		public event ColorEventHandler UserForeColorChanged;
		protected virtual void OnUserForeColorChanged(ColorBgra newColor)
		{
			if (UserForeColorChanged != null)
			{
				UserForeColorChanged(this, new ColorEventArgs(newColor));
			}
		}

        protected override void OnLoad(EventArgs e)
        {
            base.OnLoad(e);
            this.ClientSize = new Size(mainToolBar.Width - 2, mainToolBar.Height);
        }

        protected override void OnEnableStyles()
        {
            //base.OnEnableStyles ();
        }


        public MainToolBarForm()
        {
            //
            // Required for Windows Form Designer support
            //
            InitializeComponent();
        }

        /// <summary>
        /// Clean up any resources being used.
        /// </summary>
        protected override void Dispose(bool disposing)
        {
            if (disposing)
            {
                if (components != null)
                {
                    components.Dispose();
                    components = null;
                }
            }
            base.Dispose(disposing);
        }

        #region Windows Form Designer generated code
        /// <summary>
        /// Required method for Designer support - do not modify
        /// the contents of this method with the code editor.
        /// </summary>
        private void InitializeComponent()
        {
			this.mainToolBar = new PaintDotNet.MainToolBar();
			this.SuspendLayout();
			// 
			// mainToolBar
			// 
			this.mainToolBar.Dock = System.Windows.Forms.DockStyle.Top;
			this.mainToolBar.Location = new System.Drawing.Point(0, 0);
			this.mainToolBar.Name = "mainToolBar";
			this.mainToolBar.Size = new System.Drawing.Size(102, 88);
			this.mainToolBar.TabIndex = 0;
			// 
			// MainToolBarForm
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(102, 344);
			this.Controls.Add(this.mainToolBar);
			this.FormBorderStyle = System.Windows.Forms.FormBorderStyle.FixedToolWindow;
			this.Name = "MainToolBarForm";
			this.Text = "";
			this.Controls.SetChildIndex(this.mainToolBar, 0);
			this.ResumeLayout(false);

		}
        #endregion

    }
}
